/*
 *  
 *  Copyright (c) 2004 Steve Slaven, All Rights Reserved.
 *  
 *  This program is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU General Public License as
 *  published by the Free Software Foundation; either version 2 of
 *  the License, or (at your option) any later version.
 *  
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 *  GNU General Public License for more details.
 *  
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA 02111-1307 USA
 *  
*/
/* Thonis is the app singleton class */

package net.hoopajoo.cheeselab3;
import javax.imageio.*;
import javax.imageio.stream.*;
import javax.swing.*;        
import java.awt.*;
import java.io.*;
import java.net.*;
import java.awt.event.*;
import java.awt.image.*;
import java.util.*;

public class CheeseMap {
	static CheeseProgress progress = null;
	static String cachedir = "cache/_null";
	static int rclick = 0;
	static int edit_roomid = 0;
	static JFrame toplevel = null;
	static Socket sock = null;
	static BufferedInputStream in = null;
	static PrintStream out = null;
	static CheeseCanvas canvas = null;
	static CheeseMapData map = null;
	static CheeseMapRoomEditor room_editor = null;
	static CheeseMapNavigator navi = null;
	static CheeseMapFollowDialog select_follow = null;
	static volatile boolean online = false;
	
	static JToggleButton connect, follow_button;
	
	static String follow_userid = "";
	static boolean follow_player = true;
	
	static volatile boolean pinger = false;
	
	static Properties props = null;
	
	static NetworkBonanza bozo = null;
	static int last_acceptid, last_sendid;

	/*
	public static void die( String s ) {
		dmesg( s );
	}

	public static void dmesg( String s ) {
		System.out.println( s );
	}
	*/

	private static void createAndShowGUI() {
		//JFrame.setDefaultLookAndFeelDecorated( true );
		JFrame.setDefaultLookAndFeelDecorated( false );
		toplevel = new JFrame( "CheeseMap v" + CheeseLab.version );
		toplevel.setDefaultCloseOperation( JFrame.EXIT_ON_CLOSE );

		Container content = toplevel.getContentPane();

		// Setup menus
		JMenuBar bar = new JMenuBar();
		
		// File menu
		JMenu menu = new JMenu( "File" );
		JMenuItem item;
		//item = new JMenuItem( "Connect", 'C' );
		//menu.add( item );
		item = new JMenuItem( "Preferences", 'P' );
		item.addActionListener( new ActionListener() {
			public void actionPerformed(ActionEvent e) {
				CheeseMap.show_preferences();
		    }
		} );
		menu.add( item );
		item = new JMenuItem( "Change Follow", 'F' );
		item.addActionListener( new ActionListener() {
			public void actionPerformed(ActionEvent e) {
				CheeseMap.select_follow.show();
		    }
		} );
		menu.add( item );
		item = new JMenuItem( "Change Player Icon", 'I' );
		item.addActionListener( new ActionListener() {
			public void actionPerformed(ActionEvent e) {
				CheeseMap.change_avatar();
		    }
		} );
		menu.add( item );
		item = new JMenuItem( "Sync Cache", 'C' );
		item.addActionListener( new ActionListener() {
			public void actionPerformed(ActionEvent e) {
				CheeseMap.do_refresh();
		    }
		} );
		menu.add( item );
		menu.addSeparator();
		item = new JMenuItem( "Exit", 'X' );
		menu.add( item );
		bar.add( menu );
		
		// Editor menu
		menu = new JMenu( "Editor" );
		JMenu submenu = new JMenu( "Right Click" );
		ButtonGroup rclicks = new ButtonGroup();
		submenu.add( item = new JRadioButtonMenuItem( "Select" ) );
		item.setSelected( true );
		item.addActionListener( new ActionListener() {
			public void actionPerformed( ActionEvent e ) {
				CheeseMap.set_rclick( 0 );
			}
		} );
		rclicks.add( item );		
		submenu.add( item = new JRadioButtonMenuItem( "Delete" ) );
		item.addActionListener( new ActionListener() {
			public void actionPerformed( ActionEvent e ) {
				CheeseMap.set_rclick( 1 );
			}
		} );
		rclicks.add( item );
		submenu.add( item = new JRadioButtonMenuItem( "Merge" ) );
		item.addActionListener( new ActionListener() {
			public void actionPerformed( ActionEvent e ) {
				CheeseMap.set_rclick( 2 );
			}
		} );		
		rclicks.add( item );
		//submenu.add( rclicks );
		menu.add( submenu );
		
		menu.addSeparator();
		item = new JMenuItem( "Merge All", 'A' );
		item.addActionListener( new ActionListener() {
			public void actionPerformed(ActionEvent e) {
				JOptionPane.showMessageDialog( toplevel, "Not done, sorry" );
			}
		} );
		menu.add( item );
		
		bar.add( menu );
		
		toplevel.setJMenuBar( bar );
		
		// Setup toolbar
		JToolBar toolbar = new JToolBar();
		JToggleButton button = new JToggleButton( new ImageIcon( "ui/ui_connect.png" ) );
		button.setToolTipText( "Connect" );
		button.addActionListener(
			new ActionListener() {
				public void actionPerformed(ActionEvent e) {
					// do something for button b1
					CheeseLab.dmesg( 3, "Pushed connect" );
					JToggleButton b = (JToggleButton)e.getSource();
					if( b.isSelected() ) {
						CheeseLab.dmesg( 3, "Connecting" );
						connect();
					}else{
						CheeseLab.dmesg( 3, "Dis-connecting" );
						disconnect();
					}
				}
			}
		);
		toolbar.add( button );
		
		JButton bb = new JButton( new ImageIcon( "ui/ui_navigate.png" ) );
		bb.setToolTipText( "Navigate" );
		bb.addActionListener( new ActionListener() {
			public void actionPerformed( ActionEvent e ) {
				CheeseMap.navi.show();
			}
		} );
		toolbar.add( bb );

		follow_button = new JToggleButton( new ImageIcon( "ui/ui_follow.png" ) );
		follow_button.setToolTipText( "Follow" );
		follow_button.addActionListener( new ActionListener() {
			public void actionPerformed( ActionEvent e ) {
				CheeseMap.set_follow_player( ! CheeseMap.follow_player );
			}
		} );
		toolbar.add( follow_button );
		
		bb = new JButton( new ImageIcon( "ui/ui_zoomin.png" ) );
		bb.setToolTipText( "Increase Tile Size" );
		bb.addActionListener( new ActionListener() {
			public void actionPerformed( ActionEvent e ) {
				CheeseMap.resize_tiles( 5 );
			}
		} );
		toolbar.add( bb );
		bb = new JButton( new ImageIcon( "ui/ui_zoomout.png" ) );
		bb.setToolTipText( "Decrease Tile Size" );
		bb.addActionListener( new ActionListener() {
			public void actionPerformed( ActionEvent e ) {
				CheeseMap.resize_tiles( -5 );
			}
		} );
		toolbar.add( bb );


		content.add( toolbar, BorderLayout.NORTH );

		connect = button;
		
		canvas = new CheeseCanvas();
		content.add( canvas );

		map = new CheeseMapData();

		canvas.set_map( map );

		toplevel.pack();
		// TODO: remember last size/position
		Toolkit tk = Toolkit.getDefaultToolkit();
		Dimension dm = tk.getScreenSize();
		toplevel.setSize( (int)dm.getWidth(), (int)dm.getHeight() / 3 );
		toplevel.setVisible( true );
		
		load_properties();
		
		// load the room editor
		room_editor = new CheeseMapRoomEditor( toplevel );
		navi = new CheeseMapNavigator( toplevel );
		progress = new CheeseProgress( toplevel );
		select_follow = new CheeseMapFollowDialog( toplevel );
	}

	public static void set_edit_room( int roomid ) {
		CheeseLab.dmesg( 2, "setting edit room# to " + roomid );
		// Make sure it gets in the cache
		map.get_room( roomid );
		
		// TODO: make sure we get the latest?
		send_tx( 1, "ping", "set_edit_room" );
		while( ! CheeseMap.checkping() );

		set_edit_room( map.get_room( roomid ) );
	}
	
	public static void set_edit_room( CheeseRoomData r ) {
		edit_roomid = r.roomid;
		canvas.center_on( r.x, r.y, r.z );
		room_editor.set_room( r );
		room_editor.show();
	}
	
	public static void save_edit_room() {
		CheeseRoomData r = room_editor.get_room();
		send_tx( 1, "save", CheeseDecoder.encode_object( r ) );
	}

	private static void show_preferences() {
		CheeseMapConfig c = new CheeseMapConfig( toplevel, props );
		c.setVisible( true );
	}
	
	private static void load_properties() {
		props = new Properties();
		try {
			FileInputStream in = new FileInputStream( "cheesemap.cfg" );
			props.load( in );
			//props.list( System.out );
			in.close();
		}catch( Exception e ) {
			e.printStackTrace();
		}
		CheeseMap.apply_properties();
	}
	
	public static void apply_properties() {
		// apply properties
		follow_userid = props.getProperty( "userid" );
		try {
			int loglevel = Integer.parseInt( props.getProperty( "loglevel" ) );
			CheeseLab.log_level = loglevel;
		}catch( Exception e ) {
			CheeseLab.log_level = 0;
		}
	}
	
	public static void save_properties() {
		try {
			FileOutputStream out = new FileOutputStream( "cheesemap.cfg" );
			props.store( out, null );
			out.close();
		}catch( Exception e ) {
			e.printStackTrace();
		}		
	}
	
	private static void disconnect() {
		CheeseLab.dmesg( 2, "disconnect" );
		if( sock != null ) {
			connect.setSelected( false );
			if( bozo != null ) bozo.running = false;

			try { in.close();	}catch( Exception e ) {	}
			try { out.close();	}catch( Exception e ) {	}
			try { sock.close();	}catch( Exception e ) {	}

			in = null;
			out = null;
			sock = null;
			bozo = null;
		}
		online = false;
		canvas.repaint();
	}

	private static void connect() {
		disconnect();

		// Make sure username is right
		apply_properties();
		
		String password = "";
		
		if( props.getProperty( "password" ).equals( "PROMPT" ) )
			password = JOptionPane.showInputDialog( toplevel, "Password" );
		else
			password = props.getProperty( "password" );
		
		try {
			sock = new Socket( props.getProperty( "server" ), Integer.parseInt( props.getProperty( "port" ) ) );
			in = new BufferedInputStream( sock.getInputStream() );
			out = new PrintStream( sock.getOutputStream(), true );
			bozo = new NetworkBonanza();
			
			CheeseLab.dmesg( 1, "Authenticating" );
			send_tx( 1, "auth", follow_userid + ":" + password );

			connect.setSelected( true );
			
			cachedir = "cache/" +  props.getProperty( "server" ) + "_" + props.getProperty( "port" );
			map.initcache();
			
			// Send our player tile
			send_player_tile();
			set_follow_player( true );
		}catch( Exception e ) {
			CheeseLab.dmesg( 0, "Unable to connect: " + e );
			JOptionPane.showMessageDialog( toplevel, "Unable to connect: " + e );
			connect.setSelected( false );
		}
	}

	public static void send_player_tile() {
		CheeseFile f = new CheeseFile( "tiles/player_" + follow_userid + ".png" );
		send_tx( 1, "tile", CheeseDecoder.encode_object( f ) );
	}
	
	public static void do_refresh() {
		online = false; // tells map not to draw
		if( JOptionPane.showConfirmDialog( toplevel, "Are you sure you want to sync? If the database is large and you have not sync'd before it may take a loooong time!", "Confirm Sync", JOptionPane.YES_NO_OPTION ) == JOptionPane.YES_OPTION ) {			
			CheeseLab.dmesg( 2, "Performing pull of all new stuff: " + map.get_highest_mtime() );
			// Refresh should be mtime of last newest item in our cache
			send_tx( 1, "refresh", Long.toString( map.get_highest_mtime() ) );
		}else{
			online = true;
		}
	}
	
	public static int send_tx( int channel, String msgtype, String data ) {
		return( send_tx( channel, msgtype, data.getBytes() ) );
	}
	
	public static int send_tx( int channel, String msgtype, byte[] data ) {
		if( sock == null )
			return( -1 );

		last_sendid = CheeseTx.send_tx( out, last_sendid, channel, msgtype, data );
		return( 0 );		
	}

	public static int handle_tx() {
		if( sock == null )
			return( -1 );

		CheeseLab.dmesg( 2, "Handle tx" );
		CheeseTx tx = CheeseTx.accept_tx( in );
		try {
			
			// Just pull the stuff from the tx as we did it manually before
			// TODO: make this nice
			if( tx == null ) {
				CheeseLab.dmesg( 2, "Got null tx, bye" );
				disconnect();
				return( -1 );
			}
			
			int seq = tx.sequence;
			int channel = tx.channel;
			String msgtype = tx.msgtype;
			String enc = tx.enc;
			int len = tx.length;

			byte[] buffer = tx.buffer;

			CheeseLab.dmesg( 2, "msgtype is: " + msgtype );
			
			// Now based on msttype, pass the data to the proper routine
			if( msgtype.equals( "player" ) ) {
				map.update_player( buffer );
				// Set canvas x/y/z (center)
				CheesePlayerData p = map.get_player( follow_userid );

				if( p != null && follow_player ) {
					CheeseLab.dmesg( 3, "Moving origin: " + p.x + "," + p.y + "," + p.z );
					canvas.center_on( p.x, p.y, p.z );
				}
			}else if( msgtype.equals( "progress" ) ) {
				// Display a progress message, if blank then no message to display
				String message = new String( tx.buffer );
				//CheeseLab.dmesg( 0, message );
				
				if( message.equals( "CLOSE" ) ) {
					progress.hide();
				}else{
					progress.set_message( message );
					if( ! progress.isShowing() ) 
						progress.show();
				}
			}else if( msgtype.equals( "search" ) ) {
				// Search results
				navi.set_search_results( buffer );
			}else if( msgtype.equals( "auth" ) ) {
				// Now we are connected and can do stuff
				online = true;
			}else if( msgtype.equals( "ping" ) ) {
				// pings allow network sync, set pingmonitor(message)=0
				// then wait for pingmonitor(message)=1, since
				// network ops happen in sequence your response will be complete
				// when you receieve your ping
				//setping( new String( buffer ) );
				setping();
			}else if( msgtype.equals( "tile" ) ) {
				// Accept tile, the format is tilename,tiledata
				CheeseFile f = (CheeseFile)CheeseDecoder.decode_object( tx.buffer );
				f.save( cachedir + "/tiles/" );
				CheeseLab.dmesg( 2, "Accepting tile: " + f.filename );
				
				// Invalidate map cache (we should just invalidate this tile, but oh well)
				canvas.set_tile_size( canvas.tile_width, canvas.tile_height );
			}else if( msgtype.equals( "message" ) ) {
				// Display message to user
				// TODO: need a chat thing too? :p
				CheeseLab.dmesg( 2, "Got message: " + new String( tx.buffer ) );
				JOptionPane.showMessageDialog( toplevel, new String( tx.buffer ) );
			}else if( msgtype.equals( "refresh" ) ) {
				online = true;
				// refresh complete
				map.save_max_mtime();
			}else if( msgtype.equals( "map" ) ) {
				canvas.update_map( buffer );
			}else if( msgtype.equals( "world" ) ) {
				// TODO: use this in drawing optimization
				canvas.changed();
			}else if( msgtype.equals( "room" ) ) {
				map.update_room( buffer );
				canvas.changed();
			}else{
				CheeseLab.dmesg( 2, "Unknown message type: " + msgtype );
			}
		}catch( Exception e ) {
			disconnect();
		}
		return( 0 );
	}

	public static void setping() {
		pinger = true;
	}
	
	// WARNING: due to syncro issues there is only 1 pinger now
	public static boolean checkping() {
		if( sock == null )
			return( true );

		return( pinger );
	}

	public static void clearping( String msg ) {
		pinger = false;
	}

	public static void set_rclick( int how ) {
		CheeseLab.dmesg( 2, "Setting rclick: " + how );
		rclick = how;
		canvas.rclick_action = how;
	}

	public static void set_follow_player( boolean f ) {
		follow_button.setSelected( f );
		follow_player = f;
		
		// Get the playername and re-center on it if we can
		CheesePlayerData p = map.get_player( follow_userid );
		if( p != null && follow_player ) {
			canvas.center_on( p.x, p.y, p.z );
		}
	}
	
	public static void main(String[] args) {
		//Schedule a job for the event-dispatching thread:
		//creating and showing this application's GUI.
		javax.swing.SwingUtilities.invokeLater( new Runnable() {
			public void run() {
				createAndShowGUI();
				CheeseLab.dmesg( 2, "End of main_run()" );
			}
		} );
	}
	
	public static void resize_tiles( int howmuch ) {
		set_tile_size( canvas.tile_width + howmuch );
	}

	public static void set_tile_size( int size ) {
		canvas.set_tile_size( size, size );
	}
	
	public static void change_avatar() {
		JFileChooser chooser = new JFileChooser();
		
		chooser.showDialog( toplevel, "Select Avatar Image" );
		File f = chooser.getSelectedFile();
		
		if( f != null ) {
			// Read the image, and save it out.  If we are online, also push it to the server
			CheeseLab.dmesg( 0, "They chose: " + f );
			ImageIcon ii = new ImageIcon( f.getAbsolutePath() );
			
			if( ii.getIconWidth() == -1 ) {
				// Error
				JOptionPane.showMessageDialog( toplevel, "Error loading image" );
			}else{
				Image i = ii.getImage().getScaledInstance( 128, 128, Image.SCALE_SMOOTH );
				
				// Force loading
				while( ! canvas.prepareImage( i, -1, -1, (ImageObserver)canvas ) );
	
				// Resize
				BufferedImage im = new BufferedImage( 128, 128, Transparency.TRANSLUCENT );
				Graphics2D g = im.createGraphics();
				g.drawImage( i, 0, 0, null );
				g.dispose();
				
				Iterator writers = ImageIO.getImageWritersByFormatName( "png" );
				ImageWriter writer = (ImageWriter)writers.next();
	
				File output = new File( "tiles/player_" + follow_userid + ".png" );
				try {
					ImageOutputStream ios = ImageIO.createImageOutputStream( output );
					writer.setOutput( ios );
					writer.write( im );
					
					ios.close();
					
					// Clear tiles
					canvas.set_tile_size( canvas.tile_width, canvas.tile_height );
					if( sock != null )
						send_player_tile();
					
					JOptionPane.showMessageDialog( toplevel, "Avatar changed" );
				}catch( Exception e ) {
					e.printStackTrace();
				}
			}
		}
	}
	
}
